EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_access_value_and_text_set, Eina_Bool, 0, EFL_FUNC_CALL(value, text), double value, const char *text);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_access_value_and_text_get, EFL_FUNC_CALL(value, text), double *value, const char **text);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_access_value_range_get, EFL_FUNC_CALL(lower_limit, upper_limit, description), double *lower_limit, double *upper_limit, const char **description);

static Eina_Value
__eolian_efl_access_value_increment_get_reflect(const Eo *obj)
{
   double val = efl_access_value_increment_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_access_value_increment_get, double, 0);

static Eina_Bool
_efl_access_value_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_ACCESS_VALUE_EXTRA_OPS
#define EFL_ACCESS_VALUE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_access_value_and_text_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_value_and_text_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_value_range_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_access_value_increment_get, NULL),
      EFL_ACCESS_VALUE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"increment", NULL, __eolian_efl_access_value_increment_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_access_value_class_desc = {
   EO_VERSION,
   "Efl.Access.Value",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_access_value_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_access_value_interface_get, &_efl_access_value_class_desc, NULL, NULL);
